clear
disp('This program solves the diffusion-convection-absorption equation')
disp('')
disp('    -D(dDu) + cDu + au = f      (D=d/dx)')
disp('')
disp('in the domain  [xmin,xmax],')
disp('with boundary conditions')
disp('')
disp('     dDu + ku = g   or   u = g')
disp('')
disp('at  x = xmin  and  x = xmax,  respectively,')
disp('')
disp('and with energy, L2 or maximum norm error at most tol.')
%
%data input
%
xmin=input('xmin = ');
xmax=input('xmax = ');
%
diffusion=input('d(x) = ','s');
convection=input('c(x) = ','s');
absorption=input('a(x) = ','s');
force=input('f(x) = ','s');
%
k=[0 0];
input('b.c. type at  x = xmin,  n (Neuman/Robin) or d (Dirichlet) ? ','s');
if ans=='d'; bctype(1)=0; else; bctype(1)=1; end
if bctype(1)==1
k(1)=input('k = ');
end
g(1)=input('g = ');
input('b.c. type at  x = xmax,  n or d ? ','s');
if ans=='d'; bctype(2)=0; else; bctype(2)=1; end
if bctype(2)==1
k(2)=input('k = ');
end
g(2)=input('g = ');
%
errnorm=input('error norm ?  en (energy), l2  or  ma (maximum) ? ','s');
if convection=='0';
%disp('hope absorption term  a  is not (too) negative')
else
if errnorm=='en';
disp('problem non symmetric - energy norm does not exist')
disp('choose another error norm')
errnorm=input('l2  or  ma ? ','s');
end
end
tol=input('tol = ');
%
disp('is the exact solution known?  y  or  n ? ')
exactflag=input('','s');
if exactflag=='y';
disp('give  u(x) ')
uexact=input('u(x) = ','s');
end
%
run=0;
solve

