function [ok,globalerr,res]=test(ni,x,u,xold,uold,d,Dd,c,r,f,errnorm,tol,ad,al,ar,bctype)
disp('test')
h=x(2:ni+1)-x(1:ni);
%
for i=1:ni;
res(i)=f(i)+(Dd(i)-c(i))*(u(i+1)-u(i))/h(i)-r(i)*(u(i+1)+u(i))/2;
end
%
plotres=[res(1),res,res(ni)];
plotres=(plotres(1:ni+1)+plotres(2:ni+2))/2;
plotres';
subplot(312),plot(x,plotres)
title('residual')
pause(3)
%
if errnorm=='en';
%
res=abs(res)./sqrt(d);
%
cint=1/sqrt(10); %interpolation error constant in ||z-zi||<c||z'|| (where z=e)
%
%computing global energy norm error
%
res=cint*res;
globalerr=sqrt(sum((h.*res).*(h.*res).*h));
cstab=1
%
elseif errnorm=='l2';
%
xcopy=x;
adcopy=ad;
niold=size(xold,2)-1;
ndf=ni-1+sum(bctype);
%
%cint=1/sqrt(30)/2;    %interpolation error constant
cint=1/pi^2;    %interpolation error constant
%
%setting up dual problem
%
x=xcopy(1)+h(1)/2;
wl=(xold(2)-x)/(xold(2)-xold(1));
wr=(x-xold(1))/(xold(2)-xold(1));
ee=(u(2)+u(1))/2-(wl*uold(1)+wr*uold(2));
eefirst=ee;
l2e=ee*ee*h(1);
e(1)=ee*h(1)/2;
index=1;
for i=2:ni-1;
x=xcopy(i)+h(i)/2;
while xold(index)<x;
index=index+1;
end
wl=(xold(index)-x)/(xold(index)-xold(index-1));
wr=(x-xold(index-1))/(xold(index)-xold(index-1));
ee=(u(i+1)+u(i))/2-(wl*uold(index-1)+wr*uold(index));
l2e=l2e+ee*ee*h(i);
e(i-1)=e(i-1)+ee*h(i)/2;
e(i)=ee*h(i)/2;
end
x=xcopy(ni)+h(ni)/2;
wl=(xold(niold+1)-x)/(xold(niold+1)-xold(niold));
wr=(x-xold(niold))/(xold(niold+1)-xold(niold));
ee=(u(ni)+u(ni+1))/2-(wl*uold(niold)+wr*uold(niold+1));
eelast=ee;
l2e=l2e+ee*ee*h(ni);
l2e=sqrt(l2e);
e(ni-1)=e(ni-1)+ee*h(ni)/2;
%
if bctype(1)==1;
e=[eefirst*h(1)/2,e];
end
if bctype(2)==1;
e=[e,eelast*h(ni)/2];
end
%
%solving dual problem
%
adcopy=ad;
for i=2:ndf;
ad(i)=ad(i)-al(i-1)*ar(i-1)/ad(i-1);
e(i)=e(i)-e(i-1)*ar(i-1)/ad(i-1);
end
z(ndf)=e(ndf)/ad(ndf);
for i=ndf-1:-1:1;
e(i)=e(i)-e(i+1)*al(i)/ad(i+1);
z(i)=e(i)/ad(i);
end
%
if bctype(1)==0
z=[0,z];    %given boundary value
end
if bctype(2)==0
z=[z,0];    %given boundary value
end
%
%computing D2z and cstab
%
Dz=(z(2:ni+1)-z(1:ni))./h;
DDz=abs(Dz(2:ni)-Dz(1:ni-1));
DDz=[DDz(1),DDz,DDz(ni-1)];
DDz=(DDz(2:ni+1)+DDz(1:ni))/2;
DDz=DDz./h;
cstab=sqrt(sum(DDz.*DDz.*h))/l2e
%
res=cstab*cint*abs(res);
globalerr=sqrt(sum((h.*h.*res).*(h.*h.*res).*h));
%
x=xcopy;
ad=adcopy;
%
elseif errnorm=='ma';
%
adcopy=ad;
ndf=ni-1+sum(bctype);
%
cint=1/8; %interpolation constant
%
%loop over test points to determine cstab
%
cstab=0;
nitp=3;
index=[1:max(1.01,ndf/(nitp+1)):ndf];
index=round(index);
index=[index,ndf];
si=size(index,2);
for i=1:si;
%
%setting up and solving dual problem(s)
%
delta=zeros(ndf,1);
delta(index(i))=delta(index(i))+1;
%
for i=2:ndf;
ad(i)=ad(i)-al(i-1)*ar(i-1)/ad(i-1);
delta(i)=delta(i)-delta(i-1)*ar(i-1)/ad(i-1);
end
z(ndf)=delta(ndf)/ad(ndf);
for i=ndf-1:-1:1;
delta(i)=delta(i)-delta(i+1)*al(i)/ad(i+1);
z(i)=delta(i)/ad(i);
end
%
if bctype(1)==0
z=[0,z];    %given boundary value
end
if bctype(2)==0
z=[z,0];    %given boundary value
end
%
%computing D2z and cstab
%
Dz=(z(2:ni+1)-z(1:ni))./h;
DDz=abs(Dz(2:ni)-Dz(1:ni-1));
DDz=[DDz(1),DDz,DDz(ni-1)];
DDz=(DDz(2:ni+1)+DDz(1:ni))/2;
DDz=DDz./h;
cstab=max(cstab,sum(DDz.*h));
%
ad=adcopy;   %restoring diagonal in stiffness matrix
end
%
cstab
res=cstab*cint*abs(res);
globalerr=max((h.^2).*res);
%
end %of errnorm branching 
%
%subplot(312),title(['residual, stability factor =',num2str(cstab)])
%
%setting ok flag
%
if globalerr<tol
ok=1;
else
ok=-1;
end
